UML Sequence Diagram Model in EJ2 JavaScript Diagram Control

2 Jul 202624 minutes to read

A UML sequence diagram is an interaction diagram that demonstrates how objects interact with each other and the order of these interactions. The Syncfusion® diagram control provides comprehensive support for creating and visualizing UML sequence diagrams through the UmlSequenceDiagramModel. To enable this functionality, assign the UmlSequenceDiagramModel to the model property of the diagram control.

UML Sequence Diagram Elements

A sequence diagram includes several key elements, such as participants, messages, activation boxes, and fragments. The sections below demonstrate how to define and configure these components using the Diagram control.

Participants

UmlSequenceParticipantModel represents an entity that interacts with other entities in a sequence diagram. Participants appear at the top of the diagram, with lifelines extending vertically downward.

UmlSequenceParticipantModel Properties

Property Type Description
id string | number A unique identifier for the participant.
content string The display text of the participant.
showDestructionMarker boolean Indicates whether a destruction marker (X) is shown at the end of the participant lifeline.
activationBoxes UmlSequenceActivationBoxModel[] A collection of activation boxes associated with the participant.
stereotype UmlSequenceParticipantStereotype The visual stereotype used to render the participant header, such as Actor, Boundary, Control, Entity, or Database.

Participant Stereotypes

The UmlSequenceParticipantStereotype enum defines the visual style of a participant. A stereotype helps show the role of a participant in the interaction.

Stereotype Description Shape
Default Standard object participant displayed as a labeled rectangle. Default stereotype
Actor External person or system that interacts with the process. Actor stereotype
Boundary Interface or entry point, such as a UI, API gateway, or external system. Boundary stereotype
Control Object that manages the flow, such as a controller or coordinator. Control stereotype
Entity Object that represents data, domain objects, or stored information. Entity stereotype
Database Database or persistent storage system, displayed using a cylindrical shape. Database stereotype
// Define the model for the UML Sequence Diagram
var umlSequenceDiagramModel = {
  // Define the participants involved in the UML Sequence Diagram
  participants: [
    {
      id: "User", // Unique identifier for the participant
      content: "User", // Label or name of the participant
      stereotype: ej.diagrams.UmlSequenceParticipantStereotype.Actor // Indicates that the participant is an actor
    },
    {
      id: "System", // Unique identifier for the participant
      content: "System", // Label or name of the participant
      showDestructionMarker: true, // Flag to show destruction marker at the end of the lifeline
    }
  ],
};

var diagram = new ej.diagrams.Diagram(
  {
    width: '100%',
    height: '600px',
    // Specifies the model for the diagram
    model: umlSequenceDiagramModel,
    snapSettings: {constraints: ej.diagrams.SnapConstraints.None}
  },
  '#element'
);
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-popups/styles/tailwind3.css" rel="stylesheet">

    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-navigations/styles/tailwind3.css" rel="stylesheet">

    <script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>

    <div id="container">
        <div id="element"></div>
    </div>


    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

Messages

UmlSequenceMessageModel represents communication between participants and are displayed as arrows connecting lifelines.

Types of Messages

Message Type Description Example
Synchronous The sender waits for a response Synchronous Message
Asynchronous The sender continues without waiting Asynchronous Message
Reply A response to a previous message Reply Message
Create Creates a new participant Create Message
Delete Terminates a participant Delete Message
Self A message from a participant to itself Self Message

UmlSequenceMessageModel Properties

Property Type Description
id string | number A unique identifier for the message
content string The display text for the message
fromParticipantID string | number ID of the participant sending the message
toParticipantID string | number ID of the participant receiving the message
type UmlSequenceMessageType Type of the message (Synchronous, Asynchronous, Reply, Create, Delete, Self)

The following code example illustrates how to create messages:

// Define the model for the UML Sequence Diagram
var umlSequenceDiagramModel = {
  // Defines the participants involved in the sequence diagram
  participants: [
    { id: "User", content: "User", stereotype: ej.diagrams.UmlSequenceParticipantStereotype.Actor }, // User as an actor
    { id: "System", content: "System", showDestructionMarker: true, }, // System participant
    { id: "Logger", content: "Logger", showDestructionMarker: true, }, // Logger participant
    { id: "SessionManager", content: "SessionManager", } // SessionManager participant
  ],
  // Define messages exchanged between participants
  messages: [
    // User sends login request to System via Synchronous message
    {
      id: "MSG1", content: "Login Request", fromParticipantID: "User", toParticipantID: "System",
      type: ej.diagrams.UmlSequenceMessageType.Synchronous
    },
    // System replies to User with login response via Reply message
    {
      id: "MSG2", content: "Login Response", fromParticipantID: "System", toParticipantID: "User",
      type: ej.diagrams.UmlSequenceMessageType.Reply
    },
    // System sends log event to Logger via Asynchronous message
    {
      id: "MSG3", content: "Log Event", fromParticipantID: "System", toParticipantID: "Logger",
      type: ej.diagrams.UmlSequenceMessageType.Asynchronous
    },
    // System requests SessionManager to create session via Create message
    {
      id: "MSG4", content: "Create Session", fromParticipantID: "System", toParticipantID: "SessionManager",
      type: ej.diagrams.UmlSequenceMessageType.Create
    },
    // System requests SessionManager to delete session via Delete message
    {
      id: "MSG5", content: "Delete Session", fromParticipantID: "System", toParticipantID: "SessionManager",
      type: ej.diagrams.UmlSequenceMessageType.Delete
    },
    // System validates inputs itself via Self message
    {
      id: "MSG6", content: "Validate Inputs", fromParticipantID: "System", toParticipantID: "System",
      type: ej.diagrams.UmlSequenceMessageType.Self
    }
  ],
};
// Initializes diagram control
var diagram = new ej.diagrams.Diagram(
  {
    width: '100%',
    height: '700px',
    // Specifies the model for the diagram
    model: umlSequenceDiagramModel,
    snapSettings: {constraints: ej.diagrams.SnapConstraints.None}
  },
  '#element'
);
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-popups/styles/tailwind3.css" rel="stylesheet">

    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-navigations/styles/tailwind3.css" rel="stylesheet">

    <script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>

    <div id="container">
        <div id="element"></div>
    </div>


    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

Activation Boxes

UmlSequenceActivationBoxModel represents periods when a participant is active and processing a message. They appear as thin rectangles on participant lifelines.

UmlSequenceActivationBoxModel Properties

Property Type Description
id string | number A unique identifier for the activation box
startMessageID string | number ID of the message that initiates the activation
endMessageID string | number ID of the message that terminates the activation

The following code example illustrates how to create activation boxes:

// Define the UML Sequence Diagram model with participants and activation boxes
var model = {
  // Defines the participants involved in the sequence diagram
  participants: [
    {
      id: "User",
      content: "User",
      stereotype: ej.diagrams.UmlSequenceParticipantStereotype.Actor
    },
    {
      id: "System",
      content: "System",
      showDestructionMarker: true,
      // Activation boxes for System
      activationBoxes: [
        {
          id: "ActSystem", // Unique identifier for the activation box
          startMessageID: "MSG1", // Message ID that marks the start of the activation
          endMessageID: "MSG2" // Message ID that marks the end of the activation
        }
      ]
    }
  ],
  // Define messages exchanged between participants
  messages: [
    {
      id: "MSG1", content: "Login Request", fromParticipantID: "User", toParticipantID: "System",
      type: ej.diagrams.UmlSequenceMessageType.Synchronous
    },
    {
      id: "MSG2", content: "Login Response", fromParticipantID: "System", toParticipantID: "User",
      type: ej.diagrams.UmlSequenceMessageType.Reply
    }
  ],
};
// Initializes diagram control
var diagram = new ej.diagrams.Diagram(
  {
    width: '100%',
    height: '600px',
    // Specifies the model for the diagram
    model: model,
    snapSettings: {constraints: ej.diagrams.SnapConstraints.None}
  },
  '#element'
);
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-popups/styles/tailwind3.css" rel="stylesheet">

    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-navigations/styles/tailwind3.css" rel="stylesheet">

    <script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>

    <div id="container">
        <div id="element"></div>
    </div>


    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

Fragments

UmlSequenceFragmentModel groups a set of messages based on specific conditions in a sequence diagram. They are displayed as rectangular enclosures that visually separate conditional or looping interactions.

Types of Fragments

The UmlSequenceFragmentType enum defines the following fragment types:

Fragment Type Description Example
Optional Represents a sequence that is executed only if a specified condition is met; otherwise, it is skipped. Optional Fragment
Alternative Represents multiple conditional paths (if-else structure), where only one path executes based on the condition. Alternative Fragment
Loop Represents a repeating sequence of interactions that continues based on a loop condition. Loop Fragment

UmlSequenceFragmentModel Properties

Property Type Description
id string | number A unique identifier for the fragment
type UmlSequenceFragmentType Type of the fragment (Optional, Loop, Alternative)
conditions UmlSequenceFragmentConditionModel[] Collection of conditions for the fragment

UmlSequenceFragmentConditionModel Properties

Property Type Description
content string Text describing the condition or parameter
messageIds (string | number)[] Collection of message IDs included in this condition section
fragmentIds string[] Collection of nested fragments ids (for complex structures)

The following code example illustrates how to create fragments:

// Define the UML Sequence Diagram model
var model = {
  // Define the space between participants
  spaceBetweenParticipants: 300,
  participants: [
    { id: "Customer", content: "Customer", stereotype: ej.diagrams.UmlSequenceParticipantStereotype.Actor },
    { id: "OrderSystem", content: "Order System" },
    { id: "PaymentGateway", content: "Payment Gateway" }
  ],
  // Define the messages passed between participants
  messages: [
    {
      id: "MSG1", content: "Place Order", fromParticipantID: "Customer", toParticipantID: "OrderSystem",
      type: ej.diagrams.UmlSequenceMessageType.Synchronous
    },
    {
      id: "MSG2", content: "Check Stock Availability", fromParticipantID: "OrderSystem", toParticipantID: "OrderSystem",
      type: ej.diagrams.UmlSequenceMessageType.Synchronous
    },
    {
      id: "MSG3", content: "Stock Available", fromParticipantID: "OrderSystem", toParticipantID: "Customer",
      type: ej.diagrams.UmlSequenceMessageType.Reply
    },
    {
      id: "MSG4", content: "Process Payment", fromParticipantID: "OrderSystem", toParticipantID: "PaymentGateway",
      type: ej.diagrams.UmlSequenceMessageType.Synchronous
    },
    {
      id: "MSG5", content: "Payment Successful", fromParticipantID: "PaymentGateway", toParticipantID: "OrderSystem",
      type: ej.diagrams.UmlSequenceMessageType.Reply
    },
    {
      id: "MSG6", content: "Order Confirmed and Shipped", fromParticipantID: "OrderSystem", toParticipantID: "Customer",
      type: ej.diagrams.UmlSequenceMessageType.Reply
    },
    {
      id: "MSG7", content: "Payment Failed", fromParticipantID: "PaymentGateway", toParticipantID: "OrderSystem",
      type: ej.diagrams.UmlSequenceMessageType.Reply
    },
    {
      id: "MSG8", content: "Retry Payment", fromParticipantID: "OrderSystem", toParticipantID: "Customer",
      type: ej.diagrams.UmlSequenceMessageType.Reply
    }
  ],
  // Define fragments for conditional visual representation
  fragments: [
    // Child Fragment 1 (Optional)
    {
      id: 1,
      type: ej.diagrams.UmlSequenceFragmentType.Optional,
      conditions: [
        {
          content: "if item is in stock",
          messageIds: ["MSG4"]
        }
      ]
    },
    // Child Fragment 2 (Alternative)
    {
      id: 2,
      type: ej.diagrams.UmlSequenceFragmentType.Alternative,
      conditions: [
        {
          content: "if payment is successful",
          messageIds: ["MSG5", "MSG6"]
        },
        {
          content: "if payment fails",
          messageIds: ["MSG7", "MSG8"]
        }
      ]
    },
    // Parent Fragment (Loop)
    {
      id: 3,
      type: ej.diagrams.UmlSequenceFragmentType.Loop,
      conditions: [
        {
          content: "while attempts less than 3",
          // Use IDs of child fragments for nested conditions
          fragmentIds: ['1', '2'],
        }
      ]
    },
  ],
};

// Initializes diagram control
var diagram = new ej.diagrams.Diagram(
  {
    width: '100%',
    height: '600px',
    // Specifies the model for the diagram
    model: model,
    snapSettings: {constraints: ej.diagrams.SnapConstraints.None}
  },
  '#element'
);
<!DOCTYPE html>
<html lang="en">

<head>
    <title>EJ2 Diagram</title>
    <meta charset="utf-8">
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="Typescript UI Controls">
    <meta name="author" content="Syncfusion">
    <link href="index.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-popups/styles/tailwind3.css" rel="stylesheet">

    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-base/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-buttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-popups/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-splitbuttons/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-diagrams/styles/tailwind3.css" rel="stylesheet">
    <link href="https://cdn.syncfusion.com/ej2/34.1.29/ej2-navigations/styles/tailwind3.css" rel="stylesheet">

    <script src="https://cdn.syncfusion.com/ej2/34.1.29/dist/ej2.min.js" type="text/javascript"></script>
</head>

<body>

    <div id="container">
        <div id="element"></div>
    </div>


    <script>
        var ele = document.getElementById('container');
        if (ele) {
            ele.style.visibility = "visible";
        }   
    </script>
    <script src="index.js" type="text/javascript"></script>
</body>

</html>

Customizing Participant Spacing in Sequence Diagram

The spaceBetweenParticipants property in UmlSequenceDiagramModel controls the horizontal spacing between participants. The default value is 100, and it can be adjusted based on your layout requirements.

// Define the UML Sequence Diagram model
const model = {
  // Define the space between participants
  spaceBetweenParticipants: 300,
  participants: participants,    // collection of participants in the sequence diagram  
  messages: messages,            // collection of messages exchanged between participants  
  fragments: fragments           // collection of sequence diagram fragments (opt, alt, loop) 
}

UML Sequence Diagram in React Diagram Component

2 Jul 202624 minutes to read

A UML sequence diagram is a type of interaction diagram that visualizes how objects communicate with each other over time. These diagrams show the sequence of messages exchanged between participants, making them essential for understanding system interactions, API workflows, and process flows.

The Syncfusion® React Diagram component provides comprehensive support for creating and visualizing UML sequence diagrams through the UmlSequenceDiagramModel. This specialized model enables the creation of sequence diagrams with proper UML notation and automated layout capabilities.

UML Sequence Diagram Elements

A sequence diagram includes several key elements, such as participants, messages, activation boxes, and fragments. The sections below demonstrate how to define and configure these components using the Diagram control.

Participants

UmlSequenceParticipantModel represents an entity that interacts with other entities in a sequence diagram. Participants appear at the top of the diagram, with lifelines extending vertically downward.

UmlSequenceParticipantModel Properties

Property Type Description
id string | number A unique identifier for the participant.
content string The display text of the participant.
showDestructionMarker boolean Indicates whether a destruction marker (X) is shown at the end of the participant lifeline.
activationBoxes UmlSequenceActivationBoxModel[] A collection of activation boxes associated with the participant.
stereotype UmlSequenceParticipantStereotype The visual stereotype used to render the participant header, such as Actor, Boundary, Control, Entity, or Database.

Participant Stereotypes

The UmlSequenceParticipantStereotype enum defines the visual style of a participant. A stereotype helps show the role of a participant in the interaction.

Stereotype Description Shape
Default Standard object participant displayed as a labeled rectangle. Default stereotype
Actor External person or system that interacts with the process. Actor stereotype
Boundary Interface or entry point, such as a UI, API gateway, or external system. Boundary stereotype
Control Object that manages the flow, such as a controller or coordinator. Control stereotype
Entity Object that represents data, domain objects, or stored information. Entity stereotype
Database Database or persistent storage system, displayed using a cylindrical shape. Database stereotype

Creating Participants

The following code example demonstrates how to create different types of participants:

import * as React from "react";
import * as ReactDOM from "react-dom";
import { SnapConstraints, DiagramComponent, UmlSequenceParticipantStereotype } from "@syncfusion/ej2-react-diagrams";
// Define the model for the UML Sequence Diagram
const umlSequenceDiagramModel = {
  // Define the participants involved in the UML Sequence Diagram
  participants: [
    {
      id: "User", // Unique identifier for the participant
      content: "User", // Label or name of the participant
      stereotype: UmlSequenceParticipantStereotype.Actor // Indicates that the participant is an actor
    },
    {
      id: "System", // Unique identifier for the participant
      content: "System", // Label or name of the participant
      showDestructionMarker: true, // Flag to show destruction marker at the end of the lifeline
    }
  ],
};

// initialize Diagram component
function App() {
  return (
    <DiagramComponent id="container"
      width={'100%'} height={'600px'}
      model={umlSequenceDiagramModel}
      snapSettings=
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent, } from "@syncfusion/ej2-react-diagrams";
import { UmlSequenceDiagramModel, SnapConstraints, UmlSequenceParticipantStereotype } from "@syncfusion/ej2-diagrams";

// Define the model for the UML Sequence Diagram
const umlSequenceDiagramModel: UmlSequenceDiagramModel = {
  // Define the participants involved in the UML Sequence Diagram
  participants: [
    {
      id: "User", // Unique identifier for the participant
      content: "User", // Label or name of the participant
      stereotype: UmlSequenceParticipantStereotype.Actor // Indicates that the participant is an actor
    },
    {
      id: "System", // Unique identifier for the participant
      content: "System", // Label or name of the participant
      showDestructionMarker: true, // Flag to show destruction marker at the end of the lifeline
    }
  ],
};

// initialize Diagram component
function App() {
  return (
    <DiagramComponent id="container"
      width={'100%'} height={'600px'}
      model={umlSequenceDiagramModel}
      snapSettings=
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

Messages

UmlSequenceMessageModel represents communication between participants . Messages are displayed as arrows connecting lifelines and indicate the flow of information or requests between system components.

Message Types and Usage

Different message types serve specific purposes in sequence diagrams:

Message Type Description Example
Synchronous The sender waits for a response Synchronous Message
Asynchronous The sender continues without waiting Asynchronous Message
Reply A response to a previous message Reply Message
Create Creates a new participant Create Message
Delete Terminates a participant Delete Message
Self A message from a participant to itself Self Message

UmlSequenceMessageModel Properties

Property Type Description
id string | number A unique identifier for the message.
content string The display text for the message.
fromParticipantID string | number ID of the participant sending the message..
toParticipantID string | number ID of the participant receiving the message
type UmlSequenceMessageType Type of the message (Synchronous, Asynchronous, Reply, Create, Delete, Self).

Creating Messages

The following example shows how to create different types of messages between participants:

import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent } from "@syncfusion/ej2-react-diagrams";
import { SnapConstraints, UmlSequenceMessageType, UmlSequenceParticipantStereotype } from "@syncfusion/ej2-diagrams";

// Define the UML Sequence Diagram model with participants and messages
const umlSequenceDiagramModel = {
  // Defines the participants involved in the sequence diagram
  participants: [
    { id: "User", content: "User", stereotype: UmlSequenceParticipantStereotype.Actor }, // User as an actor
    { id: "System", content: "System", showDestructionMarker: true, }, // System participant
    { id: "Logger", content: "Logger", showDestructionMarker: true, }, // Logger participant
    { id: "SessionManager", content: "SessionManager" } // SessionManager participant
  ],
  // Define messages exchanged between participants
  messages: [
    // User sends login request to System via Synchronous message
    {
      id: "MSG1", content: "Login Request", fromParticipantID: "User", toParticipantID: "System",
      type: UmlSequenceMessageType.Synchronous
    },
    // System replies to User with login response via Reply message
    {
      id: "MSG2", content: "Login Response", fromParticipantID: "System", toParticipantID: "User",
      type: UmlSequenceMessageType.Reply
    },
    // System sends log event to Logger via Asynchronous message
    {
      id: "MSG3", content: "Log Event", fromParticipantID: "System", toParticipantID: "Logger",
      type: UmlSequenceMessageType.Asynchronous
    },
    // System requests SessionManager to create session via Create message
    {
      id: "MSG4", content: "Create Session", fromParticipantID: "System", toParticipantID: "SessionManager",
      type: UmlSequenceMessageType.Create
    },
    // System requests SessionManager to delete session via Delete message
    {
      id: "MSG5", content: "Delete Session", fromParticipantID: "System", toParticipantID: "SessionManager",
      type: UmlSequenceMessageType.Delete
    },
    // System validates inputs itself via Self message
    {
      id: "MSG6", content: "Validate Inputs", fromParticipantID: "System", toParticipantID: "System",
      type: UmlSequenceMessageType.Self
    }
  ],
};

// initialize Diagram component
function App() {
  return (
    <DiagramComponent id="container"
      width={'100%'} height={'700px'}
      model={umlSequenceDiagramModel}
      snapSettings=
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent } from "@syncfusion/ej2-react-diagrams";
import { SnapConstraints, UmlSequenceDiagramModel, UmlSequenceMessageType, UmlSequenceParticipantStereotype } from "@syncfusion/ej2-diagrams";

// Define the UML Sequence Diagram model with participants and messages
const umlSequenceDiagramModel: UmlSequenceDiagramModel = {
  // Defines the participants involved in the sequence diagram
  participants: [
    { id: "User", content: "User", stereotype: UmlSequenceParticipantStereotype.Actor }, // User as an actor
    { id: "System", content: "System", showDestructionMarker: true, }, // System participant
    { id: "Logger", content: "Logger", showDestructionMarker: true, }, // Logger participant
    { id: "SessionManager", content: "SessionManager" } // SessionManager participant
  ],
  // Define messages exchanged between participants
  messages: [
    // User sends login request to System via Synchronous message
    {
      id: "MSG1", content: "Login Request", fromParticipantID: "User", toParticipantID: "System",
      type: UmlSequenceMessageType.Synchronous
    },
    // System replies to User with login response via Reply message
    {
      id: "MSG2", content: "Login Response", fromParticipantID: "System", toParticipantID: "User",
      type: UmlSequenceMessageType.Reply
    },
    // System sends log event to Logger via Asynchronous message
    {
      id: "MSG3", content: "Log Event", fromParticipantID: "System", toParticipantID: "Logger",
      type: UmlSequenceMessageType.Asynchronous
    },
    // System requests SessionManager to create session via Create message
    {
      id: "MSG4", content: "Create Session", fromParticipantID: "System", toParticipantID: "SessionManager",
      type: UmlSequenceMessageType.Create
    },
    // System requests SessionManager to delete session via Delete message
    {
      id: "MSG5", content: "Delete Session", fromParticipantID: "System", toParticipantID: "SessionManager",
      type: UmlSequenceMessageType.Delete
    },
    // System validates inputs itself via Self message
    {
      id: "MSG6", content: "Validate Inputs", fromParticipantID: "System", toParticipantID: "System",
      type: UmlSequenceMessageType.Self
    }
  ],
};

// initialize Diagram component
function App() {
  return (
    <DiagramComponent id="container"
      width={'100%'} height={'700px'}
      model={umlSequenceDiagramModel}
      snapSettings=
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

Activation Boxes

UmlSequenceActivationBoxModel represents periods when a participant is actively processing or executing operations. Activation boxes appear as thin rectangles overlaid on participant lifelines, indicating the duration of active processing between specific messages.

UmlSequenceActivationBoxModel Properties

Property Type Description
id string | number A unique identifier for the activation box.
startMessageID string | number ID of the message that initiates the activation..
endMessageID string | number ID of the message that terminates the activation.

Creating Activation Boxes

The following example demonstrates how to create activation boxes that span specific message sequences:

import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent } from "@syncfusion/ej2-react-diagrams";
import { SnapConstraints, UmlSequenceMessageType, UmlSequenceParticipantStereotype } from "@syncfusion/ej2-diagrams";

// Define the UML Sequence Diagram model with participants and activation boxes
const model = {
  // Defines the participants involved in the sequence diagram
  participants: [
    {
      id: "User",
      content: "User",
      stereotype: UmlSequenceParticipantStereotype.Actor
    },
    {
      id: "System",
      content: "System",
      showDestructionMarker: true,
      // Activation boxes for System
      activationBoxes: [
        {
          id: "ActSystem", // Unique identifier for the activation box
          startMessageID: "MSG1", // Message ID that marks the start of the activation
          endMessageID: "MSG2" // Message ID that marks the end of the activation
        }
      ]
    }
  ],
  // Define messages exchanged between participants
  messages: [
    {
      id: "MSG1", content: "Login Request", fromParticipantID: "User", toParticipantID: "System",
      type: UmlSequenceMessageType.Synchronous
    },
    {
      id: "MSG2", content: "Login Response", fromParticipantID: "System", toParticipantID: "User",
      type: UmlSequenceMessageType.Reply
    }
  ],
};

// Initialize Diagram component
function App() {
  return (
    <DiagramComponent id="container"
      width={'100%'} height={'600px'}
      model={model}
      snapSettings=
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent } from "@syncfusion/ej2-react-diagrams";
import { SnapConstraints, UmlSequenceDiagramModel, UmlSequenceMessageType, UmlSequenceParticipantStereotype } from "@syncfusion/ej2-diagrams";

// Define the UML Sequence Diagram model with participants and activation boxes
const model: UmlSequenceDiagramModel = {
  // Defines the participants involved in the sequence diagram
  participants: [
    {
      id: "User",
      content: "User",
      stereotype: UmlSequenceParticipantStereotype.Actor
    },
    {
      id: "System",
      content: "System",
      showDestructionMarker: true,
      // Activation boxes for System
      activationBoxes: [
        {
          id: "ActSystem", // Unique identifier for the activation box
          startMessageID: "MSG1", // Message ID that marks the start of the activation
          endMessageID: "MSG2" // Message ID that marks the end of the activation
        }
      ]
    }
  ],
  // Define messages exchanged between participants
  messages: [
    {
      id: "MSG1", content: "Login Request", fromParticipantID: "User", toParticipantID: "System",
      type: UmlSequenceMessageType.Synchronous
    },
    {
      id: "MSG2", content: "Login Response", fromParticipantID: "System", toParticipantID: "User",
      type: UmlSequenceMessageType.Reply
    }
  ],
};

// Initialize Diagram component
function App() {
  return (
    <DiagramComponent id="container"
      width={'100%'} height={'600px'}
      model={model}
      snapSettings=
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

Fragments

UmlSequenceFragmentModel represents logical groupings of messages based on specific conditions or control structures. Fragments appear as rectangular enclosures that visually organize conditional logic, loops, and alternative execution paths within sequence diagrams.

Fragment Applications

Fragments are essential for modeling:

  • Conditional logic (if-then-else statements).
  • Iterative processes (loops and repetitions).
  • Optional operations that may or may not execute.
  • Error handling and exception flows.
  • Parallel processing scenarios.

Fragment Types

The UmlSequenceFragmentType enum defines the following fragment types:

Fragment Type Description Example
Optional Represents a sequence that is executed only if a specified condition is met; otherwise, it is skipped. Optional Fragment
Alternative Represents multiple conditional paths (if-else structure), where only one path executes based on the condition. Alternative Fragment
Loop Represents a repeating sequence of interactions that continues based on a loop condition. Loop Fragment

UmlSequenceFragmentModel Properties

Property Type Description
id string | number A unique identifier for the fragment.
type UmlSequenceFragmentType Type of the fragment (Optional, Loop, Alternative).
conditions UmlSequenceFragmentConditionModel[] Collection of conditions for the fragment.

UmlSequenceFragmentConditionModel Properties

Property Type Description
content string Text describing the condition or parameter.
messageIds (string | number)[] Collection of message IDs included in this condition section.
fragmentIds string[] Collection of nested fragments ids (for complex structures).

Creating Fragments

The following example illustrates how to create fragments with different condition types:

import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent } from "@syncfusion/ej2-react-diagrams";
import { SnapConstraints, UmlSequenceMessageType, UmlSequenceFragmentType, UmlSequenceParticipantStereotype } from "@syncfusion/ej2-diagrams";

// Define the UML Sequence Diagram model
const model = {
  // Define the space between participants
  spaceBetweenParticipants: 300,
  participants: [
    { id: "Customer", content: "Customer", stereotype: UmlSequenceParticipantStereotype.Actor },
    { id: "OrderSystem", content: "Order System" },
    { id: "PaymentGateway", content: "Payment Gateway" }
  ],
  // Define the messages passed between participants
  messages: [
    {
      id: "MSG1", content: "Place Order", fromParticipantID: "Customer", toParticipantID: "OrderSystem",
      type: UmlSequenceMessageType.Synchronous
    },
    {
      id: "MSG2", content: "Check Stock Availability", fromParticipantID: "OrderSystem", toParticipantID: "OrderSystem",
      type: UmlSequenceMessageType.Synchronous
    },
    {
      id: "MSG3", content: "Stock Available", fromParticipantID: "OrderSystem", toParticipantID: "Customer",
      type: UmlSequenceMessageType.Reply
    },
    {
      id: "MSG4", content: "Process Payment", fromParticipantID: "OrderSystem", toParticipantID: "PaymentGateway",
      type: UmlSequenceMessageType.Synchronous
    },
    {
      id: "MSG5", content: "Payment Successful", fromParticipantID: "PaymentGateway", toParticipantID: "OrderSystem",
      type: UmlSequenceMessageType.Reply
    },
    {
      id: "MSG6", content: "Order Confirmed and Shipped", fromParticipantID: "OrderSystem", toParticipantID: "Customer",
      type: UmlSequenceMessageType.Reply
    },
    {
      id: "MSG7", content: "Payment Failed", fromParticipantID: "PaymentGateway", toParticipantID: "OrderSystem",
      type: UmlSequenceMessageType.Reply
    },
    {
      id: "MSG8", content: "Retry Payment", fromParticipantID: "OrderSystem", toParticipantID: "Customer",
      type: UmlSequenceMessageType.Reply
    }
  ],
  // Define fragments for conditional visual representation
  fragments: [
    // Child Fragment 1 (Optional)
    {
      id: 1,
      type: UmlSequenceFragmentType.Optional,
      conditions: [
        {
          content: "if item is in stock",
          messageIds: ["MSG4"]
        }
      ]
    },
    // Child Fragment 2 (Alternative)
    {
      id: 2,
      type: UmlSequenceFragmentType.Alternative,
      conditions: [
        {
          content: "if payment is successful",
          messageIds: ["MSG5", "MSG6"]
        },
        {
          content: "if payment fails",
          messageIds: ["MSG7", "MSG8"]
        }
      ]
    },
    // Parent Fragment (Loop)
    {
      id: 3,
      type: UmlSequenceFragmentType.Loop,
      conditions: [
        {
          content: "while attempts less than 3",
          // Use IDs of child fragments for nested conditions
          fragmentIds: ['1', '2'],
        }
      ]
    },
  ],
};


// Initialize Diagram component
function App() {
  return (
    <DiagramComponent id="container"
      width={'100%'} height={'700px'}
      model={model}
      snapSettings=
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);
import * as React from "react";
import * as ReactDOM from "react-dom";
import { DiagramComponent } from "@syncfusion/ej2-react-diagrams";
import { SnapConstraints, UmlSequenceDiagramModel, UmlSequenceMessageType, UmlSequenceFragmentType, UmlSequenceParticipantStereotype } from "@syncfusion/ej2-diagrams";

// Define the UML Sequence Diagram model
const model: UmlSequenceDiagramModel = {
  // Define the space between participants
  spaceBetweenParticipants: 300,
  participants: [
    { id: "Customer", content: "Customer", stereotype: UmlSequenceParticipantStereotype.Actor },
    { id: "OrderSystem", content: "Order System" },
    { id: "PaymentGateway", content: "Payment Gateway" }
  ],
  // Define the messages passed between participants
  messages: [
    {
      id: "MSG1", content: "Place Order", fromParticipantID: "Customer", toParticipantID: "OrderSystem",
      type: UmlSequenceMessageType.Synchronous
    },
    {
      id: "MSG2", content: "Check Stock Availability", fromParticipantID: "OrderSystem", toParticipantID: "OrderSystem",
      type: UmlSequenceMessageType.Synchronous
    },
    {
      id: "MSG3", content: "Stock Available", fromParticipantID: "OrderSystem", toParticipantID: "Customer",
      type: UmlSequenceMessageType.Reply
    },
    {
      id: "MSG4", content: "Process Payment", fromParticipantID: "OrderSystem", toParticipantID: "PaymentGateway",
      type: UmlSequenceMessageType.Synchronous
    },
    {
      id: "MSG5", content: "Payment Successful", fromParticipantID: "PaymentGateway", toParticipantID: "OrderSystem",
      type: UmlSequenceMessageType.Reply
    },
    {
      id: "MSG6", content: "Order Confirmed and Shipped", fromParticipantID: "OrderSystem", toParticipantID: "Customer",
      type: UmlSequenceMessageType.Reply
    },
    {
      id: "MSG7", content: "Payment Failed", fromParticipantID: "PaymentGateway", toParticipantID: "OrderSystem",
      type: UmlSequenceMessageType.Reply
    },
    {
      id: "MSG8", content: "Retry Payment", fromParticipantID: "OrderSystem", toParticipantID: "Customer",
      type: UmlSequenceMessageType.Reply
    }
  ],
  // Define fragments for conditional visual representation
  fragments: [
    // Child Fragment 1 (Optional)
    {
      id: 1,
      type: UmlSequenceFragmentType.Optional,
      conditions: [
        {
          content: "if item is in stock",
          messageIds: ["MSG4"]
        }
      ]
    },
    // Child Fragment 2 (Alternative)
    {
      id: 2,
      type: UmlSequenceFragmentType.Alternative,
      conditions: [
        {
          content: "if payment is successful",
          messageIds: ["MSG5", "MSG6"]
        },
        {
          content: "if payment fails",
          messageIds: ["MSG7", "MSG8"]
        }
      ]
    },
    // Parent Fragment (Loop)
    {
      id: 3,
      type: UmlSequenceFragmentType.Loop,
      conditions: [
        {
          content: "while attempts less than 3",
          // Use IDs of child fragments for nested conditions
          fragmentIds: ['1', '2'],
        }
      ]
    },
  ],
};

// Initialize Diagram component
function App() {
  return (
    <DiagramComponent id="container"
      width={'100%'} height={'700px'}
      model={model}
      snapSettings=
    />
  );
}
const root = ReactDOM.createRoot(document.getElementById('diagram'));
root.render(<App />);

Customization Options

Adjusting Participant Spacing

The spaceBetweenParticipants property controls the horizontal spacing between participants in the sequence diagram. Adjust this value to accommodate longer message labels or improve diagram readability.

// Define the UML Sequence Diagram model
const model = {
  // Define the space between participants
  spaceBetweenParticipants: 300,
  participants: participants,    // collection of participants in the sequence diagram  
  messages: messages,            // collection of messages exchanged between participants  
  fragments: fragments           // collection of sequence diagram fragments (opt, alt, loop) 
}

UML Sequence Diagram in Angular Diagram Component

7 Jul 202624 minutes to read

A UML sequence diagram is a type of interaction diagram that visualizes how objects communicate with each other over time. These diagrams show the sequence of messages exchanged between participants, making them essential for understanding system interactions, API workflows, and process flows.

The Syncfusion® Angular Diagram component provides comprehensive support for creating and visualizing UML sequence diagrams through the UmlSequenceDiagramModel. This specialized model enables the creation of sequence diagrams with proper UML notation and automated layout capabilities.

Prerequisites

Before creating UML sequence diagrams, ensure that:

  • Angular development environment is set up
  • Syncfusion Angular Diagram package is installed and imported
  • Basic familiarity with UML sequence diagram concepts

Key Concepts

Lifelines

Lifelines are vertical dashed lines that represent the existence of a participant over time. Each participant has a corresponding lifeline that extends downward from the participant box.

Sequence Flow

Messages flow horizontally between lifelines in chronological order from top to bottom, representing the temporal sequence of interactions.

UML Sequence Diagram Elements

A sequence diagram comprises several essential elements that work together to represent system interactions. The following sections demonstrate how to define and configure these components.

Participants

UmlSequenceParticipantModel represents the entities that participate in the interaction sequence. Participants appear as rectangular boxes at the top of the diagram, with lifelines extending vertically downward to show their existence throughout the interaction timeline.

Participant Types

Participants can be displayed in two forms:

  • Actors: Human users or external systems (displayed with stick figure notation)
  • Objects: System components, classes, or services (displayed as rectangular boxes)

UmlSequenceParticipantModel Properties

Property Type Description
id string | number A unique identifier for the participant
content string The display text for the participant
showDestructionMarker boolean Indicates whether a destruction marker (X) is shown at the end of the lifeline
activationBoxes UmlSequenceActivationBoxModel[] A collection of activation boxes associated with the participant
stereotype UmlSequenceParticipantStereotype The visual stereotype that determines how this participant is rendered (for example, Actor, Boundary, Control, Entity, Database).

Participant Stereotypes

The UmlSequenceParticipantStereotype enum defines the visual style of a participant. A stereotype helps show the role of a participant in the interaction.

Stereotype Description Shape
Default A standard object participant rendered as a labelled rectangular box Default
Actor An actor that interacts with the system, rendered as a UML actor (stick figure) Actor
Boundary A boundary object or system interface (UI, API gateway, external system) Boundary
Control A control object for coordinator, controller, or workflow elements Control
Entity An entity object for passive data, domain, or persistent objects Entity
Database A database or persistent storage system, rendered as a cylindrical shape Database
import { Component, ViewEncapsulation, ViewChild } from '@angular/core';
import { DiagramComponent, DiagramModule } from '@syncfusion/ej2-angular-diagrams';
import { UmlSequenceDiagramModel, SnapSettingsModel, SnapConstraints, UmlSequenceParticipantStereotype } from "@syncfusion/ej2-diagrams";

@Component({
  imports: [DiagramModule],
  standalone: true,
  selector: 'app-container',
  template: `<ejs-diagram #diagram id="diagram" width="100%" height="600px" (created)="diagramCreated()" [snapSettings]="snapSettings">
             </ejs-diagram>`,
  encapsulation: ViewEncapsulation.None,
})
export class AppComponent {
  @ViewChild('diagram', { static: false })
  public diagram?: DiagramComponent;
  public snapSettings: SnapSettingsModel = { constraints: SnapConstraints.None };
  diagramCreated() {
    // Check whether the diagram component is initialized
    if (this.diagram) {
      // Define the model for the UML Sequence Diagram
      const umlSequenceDiagramModel: UmlSequenceDiagramModel = {
        // Define the participants involved in the UML Sequence Diagram
        participants: [
          {
            id: "User", // Unique identifier for the participant
            content: "User", // Label or name of the participant
            stereotype: UmlSequenceParticipantStereotype.Actor // Indicates that the participant is an actor
          },
          {
            id: "System", // Unique identifier for the participant
            content: "System", // Label or name of the participant
            // Flag to show destruction marker at the end of the lifeline
            showDestructionMarker: true,
          }
        ],
      };
      // Specifies the model for the diagram
      this.diagram.model = umlSequenceDiagramModel;
      this.diagram.updateFromModel();
    }
  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Messages

UmlSequenceMessageModel represents communication between participants. Messages are displayed as arrows connecting lifelines and indicate the flow of information or requests between system components.

Message Types and Usage

Different message types serve specific purposes in sequence diagrams:

Message Type Description When to Use Example
Synchronous The sender waits for a response before continuing Method calls, API requests requiring immediate response Synchronous Message
Asynchronous The sender continues without waiting for a response Event notifications, fire-and-forget operations Asynchronous Message
Reply A response message to a previous synchronous call Return values, acknowledgments Reply Message
Create Creates a new participant instance during execution Object instantiation, service initialization Create Message
Delete Terminates a participant and ends its lifeline Object destruction, service shutdown Delete Message
Self A message from a participant to itself Internal processing, recursive calls Self Message

UmlSequenceMessageModel Properties

Property Type Description
id string | number A unique identifier for the message
content string The display text for the message
fromParticipantID string | number ID of the participant sending the message
toParticipantID string | number ID of the participant receiving the message
type UmlSequenceMessageType Type of the message (Synchronous, Asynchronous, Reply, Create, Delete, Self)

Creating Messages

The following example shows how to create different types of messages between participants:

import { Component, ViewEncapsulation, ViewChild } from '@angular/core';
import { DiagramComponent, DiagramModule } from '@syncfusion/ej2-angular-diagrams';
import { UmlSequenceDiagramModel, UmlSequenceMessageType, SnapSettingsModel, SnapConstraints, UmlSequenceParticipantStereotype } from "@syncfusion/ej2-diagrams";

@Component({
  imports: [DiagramModule],
  standalone: true,
  selector: 'app-container',
  template: `<ejs-diagram #diagram id="diagram" width="100%" height="700px" (created)="diagramCreated()" [snapSettings]="snapSettings">
             </ejs-diagram>`,
  encapsulation: ViewEncapsulation.None,
})
export class AppComponent {
  @ViewChild('diagram', { static: false })
  public diagram?: DiagramComponent;
  public snapSettings: SnapSettingsModel = { constraints: SnapConstraints.None };
  diagramCreated() {
    // Check whether the diagram component is initialized
    if (this.diagram) {
      // Define the model for the UML Sequence Diagram
      // Define the UML Sequence Diagram model with participants and messages
      const umlSequenceDiagramModel: UmlSequenceDiagramModel = {
        // Defines the participants involved in the sequence diagram
        participants: [
          { id: "User", content: "User", stereotype: UmlSequenceParticipantStereotype.Actor }, // User as an actor
          { id: "System", content: "System", showDestructionMarker: true, }, // System participant
          { id: "Logger", content: "Logger", showDestructionMarker: true, }, // Logger participant
          { id: "SessionManager", content: "SessionManager" } // SessionManager participant
        ],
        // Define messages exchanged between participants
        messages: [
          // User sends login request to System via Synchronous message
          {
            id: "MSG1", content: "Login Request", fromParticipantID: "User", toParticipantID: "System",
            type: UmlSequenceMessageType.Synchronous
          },
          // System replies to User with login response via Reply message
          {
            id: "MSG2", content: "Login Response", fromParticipantID: "System", toParticipantID: "User",
            type: UmlSequenceMessageType.Reply
          },
          // System sends log event to Logger via Asynchronous message
          {
            id: "MSG3", content: "Log Event", fromParticipantID: "System", toParticipantID: "Logger",
            type: UmlSequenceMessageType.Asynchronous
          },
          // System requests SessionManager to create session via Create message
          {
            id: "MSG4", content: "Create Session", fromParticipantID: "System", toParticipantID: "SessionManager",
            type: UmlSequenceMessageType.Create
          },
          // System requests SessionManager to delete session via Delete message
          {
            id: "MSG5", content: "Delete Session", fromParticipantID: "System", toParticipantID: "SessionManager",
            type: UmlSequenceMessageType.Delete
          },
          // System validates inputs itself via Self message
          {
            id: "MSG6", content: "Validate Inputs", fromParticipantID: "System", toParticipantID: "System",
            type: UmlSequenceMessageType.Self
          }
        ],
      };
      // Specifies the model for the diagram
      this.diagram.model = umlSequenceDiagramModel;
      this.diagram.updateFromModel();
    }
  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Activation Boxes

UmlSequenceActivationBoxModel represents periods when a participant is actively processing or executing operations. Activation boxes appear as thin rectangles overlaid on participant lifelines, indicating the duration of active processing between specific messages.

UmlSequenceActivationBoxModel Properties

Property Type Description
id string | number A unique identifier for the activation box
startMessageID string | number ID of the message that initiates the activation
endMessageID string | number ID of the message that terminates the activation

Creating Activation Boxes

The following example demonstrates how to create activation boxes that span specific message sequences:

import { Component, ViewEncapsulation, ViewChild } from '@angular/core';
import { DiagramComponent, DiagramModule } from '@syncfusion/ej2-angular-diagrams';
import { UmlSequenceDiagramModel, UmlSequenceMessageType, SnapSettingsModel, SnapConstraints, UmlSequenceParticipantStereotype } from "@syncfusion/ej2-diagrams";

@Component({
  imports: [DiagramModule],
  standalone: true,
  selector: 'app-container',
  template: `<ejs-diagram #diagram id="diagram" width="100%" height="600px" (created)="diagramCreated()" [snapSettings]="snapSettings">
             </ejs-diagram>`,
  encapsulation: ViewEncapsulation.None,
})
export class AppComponent {
  @ViewChild('diagram', { static: false })
  public diagram?: DiagramComponent;
  public snapSettings: SnapSettingsModel = { constraints: SnapConstraints.None };
  diagramCreated() {
    // Check whether the diagram component is initialized
    if (this.diagram) {
      // Define the model for the UML Sequence Diagram
      // Define the UML Sequence Diagram model with participants and activation boxes
      const model: UmlSequenceDiagramModel = {
        // Defines the participants involved in the sequence diagram
        participants: [
          {
            id: "User",
            content: "User",
            stereotype: UmlSequenceParticipantStereotype.Actor
          },
          {
            id: "System",
            content: "System",
            showDestructionMarker: true,
            // Activation boxes for System
            activationBoxes: [
              {
                id: "ActSystem", // Unique identifier for the activation box
                startMessageID: "MSG1", // Message ID that marks the start of the activation
                endMessageID: "MSG2" // Message ID that marks the end of the activation
              }
            ]
          }
        ],
        // Define messages exchanged between participants
        messages: [
          {
            id: "MSG1", content: "Login Request", fromParticipantID: "User", toParticipantID: "System",
            type: UmlSequenceMessageType.Synchronous
          },
          {
            id: "MSG2", content: "Login Response", fromParticipantID: "System", toParticipantID: "User",
            type: UmlSequenceMessageType.Reply
          }
        ],
      };
      // Specifies the model for the diagram
      this.diagram.model = model;
      this.diagram.updateFromModel();
    }
  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Fragments

UmlSequenceFragmentModel represents logical groupings of messages based on specific conditions or control structures. Fragments appear as rectangular enclosures that visually organize conditional logic, loops, and alternative execution paths within sequence diagrams.

Fragment Applications

Fragments are essential for modeling:

  • Conditional logic (if-then-else statements)
  • Iterative processes (loops and repetitions)
  • Optional operations that may or may not execute
  • Error handling and exception flows
  • Parallel processing scenarios

Fragment Types

The UmlSequenceFragmentType enum defines the following fragment types:

Fragment Type Description Use Cases Example
Optional Executes enclosed messages only if a specified condition is met Feature toggles, optional validations, conditional processing Optional Fragment
Alternative Provides multiple conditional paths where only one executes based on the condition Decision trees, error handling, branching logic Alternative Fragment
Loop Repeats the enclosed message sequence based on a loop condition Data processing iterations, retry mechanisms, batch operations Loop Fragment

UmlSequenceFragmentModel Properties

Property Type Description
id string | number A unique identifier for the fragment
type UmlSequenceFragmentType Type of the fragment (Optional, Loop, Alternative)
conditions UmlSequenceFragmentConditionModel[] Collection of conditions for the fragment

UmlSequenceFragmentConditionModel Properties

Property Type Description
content string Text describing the condition or parameter
messageIds (string | number)[] Collection of message IDs included in this condition section
fragmentIds string[] Collection of nested fragments ids (for complex structures)

Creating Fragments

The following example illustrates how to create fragments with different condition types:

import { Component, ViewEncapsulation, ViewChild } from '@angular/core';
import { DiagramComponent, DiagramModule } from '@syncfusion/ej2-angular-diagrams';
import { UmlSequenceDiagramModel, UmlSequenceMessageType, UmlSequenceFragmentType, SnapSettingsModel, SnapConstraints, UmlSequenceParticipantStereotype } from "@syncfusion/ej2-diagrams";

@Component({
  imports: [DiagramModule],
  standalone: true,
  selector: 'app-container',
  template: `<ejs-diagram #diagram id="diagram" width="100%" height="700px" (created)="diagramCreated()" [snapSettings]="snapSettings">
             </ejs-diagram>`,
  encapsulation: ViewEncapsulation.None,
})
export class AppComponent {
  @ViewChild('diagram', { static: false })
  public diagram?: DiagramComponent;
  public snapSettings: SnapSettingsModel = { constraints: SnapConstraints.None };
  diagramCreated() {
    // Check whether the diagram component is initialized
    if (this.diagram) {
      // Define the UML Sequence Diagram model
      const model: UmlSequenceDiagramModel = {
        // Define the space between participants
        spaceBetweenParticipants: 300,
        participants: [
          { id: "Customer", content: "Customer", stereotype: UmlSequenceParticipantStereotype.Actor },
          { id: "OrderSystem", content: "Order System"},
          { id: "PaymentGateway", content: "Payment Gateway" }
        ],
        // Define the messages passed between participants
        messages: [
          {
            id: "MSG1", content: "Place Order", fromParticipantID: "Customer", toParticipantID: "OrderSystem",
            type: UmlSequenceMessageType.Synchronous
          },
          {
            id: "MSG2", content: "Check Stock Availability", fromParticipantID: "OrderSystem", toParticipantID: "OrderSystem",
            type: UmlSequenceMessageType.Synchronous
          },
          {
            id: "MSG3", content: "Stock Available", fromParticipantID: "OrderSystem", toParticipantID: "Customer",
            type: UmlSequenceMessageType.Reply
          },
          {
            id: "MSG4", content: "Process Payment", fromParticipantID: "OrderSystem", toParticipantID: "PaymentGateway",
            type: UmlSequenceMessageType.Synchronous
          },
          {
            id: "MSG5", content: "Payment Successful", fromParticipantID: "PaymentGateway", toParticipantID: "OrderSystem",
            type: UmlSequenceMessageType.Reply
          },
          {
            id: "MSG6", content: "Order Confirmed and Shipped", fromParticipantID: "OrderSystem", toParticipantID: "Customer",
            type: UmlSequenceMessageType.Reply
          },
          {
            id: "MSG7", content: "Payment Failed", fromParticipantID: "PaymentGateway", toParticipantID: "OrderSystem",
            type: UmlSequenceMessageType.Reply
          },
          {
            id: "MSG8", content: "Retry Payment", fromParticipantID: "OrderSystem", toParticipantID: "Customer",
            type: UmlSequenceMessageType.Reply
          }
        ],
        // Define fragments for conditional visual representation
        fragments: [
          // Child Fragment 1 (Optional)
          {
            id: 1,
            type: UmlSequenceFragmentType.Optional,
            conditions: [
              {
                content: "if item is in stock",
                messageIds: ["MSG4"]
              }
            ]
          },
          // Child Fragment 2 (Alternative)
          {
            id: 2,
            type: UmlSequenceFragmentType.Alternative,
            conditions: [
              {
                content: "if payment is successful",
                messageIds: ["MSG5", "MSG6"]
              },
              {
                content: "if payment fails",
                messageIds: ["MSG7", "MSG8"]
              }
            ]
          },
          // Parent Fragment (Loop)
          {
            id: 3,
            type: UmlSequenceFragmentType.Loop,
            conditions: [
              {
                content: "while attempts less than 3",
                // Use IDs of child fragments for nested conditions
                fragmentIds: ['1', '2'],
              }
            ]
          },
        ],
      };
      // Specifies the model for the diagram
      this.diagram.model = model;
      this.diagram.updateFromModel();
    }
  }
}
import { bootstrapApplication } from '@angular/platform-browser';
import { AppComponent } from './app.component';
import 'zone.js';
bootstrapApplication(AppComponent).catch((err) => console.error(err));

Customization Options

Adjusting Participant Spacing

The spaceBetweenParticipants property controls the horizontal spacing between participants in the sequence diagram. Adjust this value to accommodate longer message labels or improve diagram readability.

// Define the UML Sequence Diagram model with custom spacing
const model: UmlSequenceDiagramModel = {
  // Increase space between participants for better readability
  spaceBetweenParticipants: 300,
  participants: participants,    // collection of participants in the sequence diagram  
  messages: messages,            // collection of messages exchanged between participants  
  fragments: fragments           // collection of sequence diagram fragments (opt, alt, loop) 
}

UML Sequence Diagram in Vue Diagram component

11 Jul 202624 minutes to read

A UML sequence diagram is an interaction diagram that demonstrates how objects interact with each other and the order of these interactions. The Vue Diagram control provides comprehensive support for creating and visualizing UML sequence diagrams through the UmlSequenceDiagramModel. To enable this functionality, assign the UmlSequenceDiagramModel to the model property of the diagram control.

UML Sequence Diagram Elements

A sequence diagram includes several key elements, such as participants, messages, activation boxes, and fragments. The sections below demonstrate how to define and configure these components using the Diagram control.

Participants

UmlSequenceParticipantModel represents an entity that interacts with other entities in a sequence diagram. Participants appear at the top of the diagram, with lifelines extending vertically downward.

UmlSequenceParticipantModel Properties

Property Type Description
id string | number A unique identifier for the participant.
content string The display text of the participant.
showDestructionMarker boolean Indicates whether a destruction marker (X) is shown at the end of the participant lifeline.
activationBoxes UmlSequenceActivationBoxModel[] A collection of activation boxes associated with the participant.
stereotype UmlSequenceParticipantStereotype The visual stereotype used to render the participant header, such as Actor, Boundary, Control, Entity, or Database.

Participant Stereotypes

The UmlSequenceParticipantStereotype enum defines the visual style of a participant. A stereotype helps show the role of a participant in the interaction.

Stereotype Description Shape
Default Standard object participant displayed as a labeled rectangle. Default stereotype
Actor External person or system that interacts with the process. Actor stereotype
Boundary Interface or entry point, such as a UI, API gateway, or external system. Boundary stereotype
Control Object that manages the flow, such as a controller or coordinator. Control stereotype
Entity Object that represents data, domain objects, or stored information. Entity stereotype
Database Database or persistent storage system, displayed using a cylindrical shape. Database stereotype
<template>
  <div id="app">
    <ejs-diagram ref="diagramRef" id="diagram" width="100%" height="600px" :snapSettings='snapSettings' />
  </div>
</template>

<script setup>
import { ref, onMounted } from 'vue';
import { DiagramComponent as EjsDiagram, SnapConstraints,UmlSequenceParticipantStereotype } from '@syncfusion/ej2-vue-diagrams';

// Define the model for the UML Sequence Diagram
const model = {
  // Define the participants involved in the UML Sequence Diagram
  participants: [
    {
      id: "User", // Unique identifier for the participant
      content: "User", // Label or name of the participant
      stereotype: UmlSequenceParticipantStereotype.Actor // Indicates that the participant is an actor
    },
    {
      id: "System", // Unique identifier for the participant
      content: "System", // Label or name of the participant
      
      showDestructionMarker: true, // Flag to show destruction marker at the end of the lifeline
    }
  ],
};

const snapSettings = { constraints: SnapConstraints.None };
const diagramRef = ref(null);

onMounted(() => {
  // Retrieve the diagram instance
  const diagramInstance = diagramRef.value.ej2Instances;
  diagramInstance.model = model;
  diagramInstance.updateFromModel();
});
</script>

<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
  <div id="app">
    <ejs-diagram ref="diagramRef" id="diagram" width="100%" height="600px" :snapSettings='snapSettings'/>
  </div>
</template>

<script>
import { DiagramComponent,SnapConstraints,UmlSequenceParticipantStereotype } from "@syncfusion/ej2-vue-diagrams";

const model = {
  // Define the participants involved in the UML Sequence Diagram
  participants: [
    {
      id: "User", // Unique identifier for the participant
      content: "User", // Label or name of the participant
      stereotype: UmlSequenceParticipantStereotype.Actor // Indicates that the participant is an actor
    },
    {
      id: "System", // Unique identifier for the participant
      content: "System", // Label or name of the participant
      showDestructionMarker: true, // Flag to show destruction marker at the end of the lifeline
    }
  ],
};

const snapSettings = { constraints: SnapConstraints.None };

export default {
  name: "App",
  components: { "ejs-diagram": DiagramComponent },
  data() {
      return {
          snapSettings: snapSettings
      }
  },
  mounted() {
    // Retrieve the diagram instance
    const diagramInstance = this.$refs.diagramRef.ej2Instances;
    diagramInstance.model = model;
    diagramInstance.updateFromModel();
  },
};
</script>

<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

Messages

UmlSequenceMessageModel represents communication between participants and are displayed as arrows connecting lifelines.

Types of Messages

Message Type Description Example
Synchronous The sender waits for a response Synchronous Message
Asynchronous The sender continues without waiting Asynchronous Message
Reply A response to a previous message Reply Message
Create Creates a new participant Create Message
Delete Terminates a participant Delete Message
Self A message from a participant to itself Self Message

UmlSequenceMessageModel Properties

Property Type Description
id string | number A unique identifier for the message
content string The display text for the message
fromParticipantID string | number ID of the participant sending the message
toParticipantID string | number ID of the participant receiving the message
type UmlSequenceMessageType Type of the message (Synchronous, Asynchronous, Reply, Create, Delete, Self)

The following code example illustrates how to create messages:

<template>
  <div id="app">
    <ejs-diagram ref="diagramRef" id="diagram" width="100%" height="700px" :snapSettings='snapSettings'/>
  </div>
</template>

<script setup>
import { ref, onMounted } from 'vue';
import { DiagramComponent as EjsDiagram } from '@syncfusion/ej2-vue-diagrams';
import { UmlSequenceMessageType, SnapConstraints, UmlSequenceParticipantStereotype } from '@syncfusion/ej2-diagrams';

// Define the UML Sequence Diagram model with participants and messages
const model = {
  // Defines the participants involved in the sequence diagram
   participants: [
    { id: "User", content: "User", stereotype: UmlSequenceParticipantStereotype.Actor }, // User as an actor
    { id: "System", content: "System", showDestructionMarker: true, }, // System participant
    { id: "Logger", content: "Logger", showDestructionMarker: true, }, // Logger participant
    { id: "SessionManager", content: "SessionManager", } // SessionManager participant
  ],
  // Define messages exchanged between participants
  messages: [
    // User sends login request to System via Synchronous message
    {
      id: "MSG1", content: "Login Request", fromParticipantID: "User", toParticipantID: "System",
      type: UmlSequenceMessageType.Synchronous
    },
    // System replies to User with login response via Reply message
    {
      id: "MSG2", content: "Login Response", fromParticipantID: "System", toParticipantID: "User",
      type: UmlSequenceMessageType.Reply
    },
    // System sends log event to Logger via Asynchronous message
    {
      id: "MSG3", content: "Log Event", fromParticipantID: "System", toParticipantID: "Logger",
      type: UmlSequenceMessageType.Asynchronous
    },
    // System requests SessionManager to create session via Create message
    {
      id: "MSG4", content: "Create Session", fromParticipantID: "System", toParticipantID: "SessionManager",
      type: UmlSequenceMessageType.Create
    },
    // System requests SessionManager to delete session via Delete message
    {
      id: "MSG5", content: "Delete Session", fromParticipantID: "System", toParticipantID: "SessionManager",
      type: UmlSequenceMessageType.Delete
    },
    // System validates inputs itself via Self message
    {
      id: "MSG6", content: "Validate Inputs", fromParticipantID: "System", toParticipantID: "System",
      type: UmlSequenceMessageType.Self
    }
  ],
};

const snapSettings = { constraints: SnapConstraints.None };
const diagramRef = ref(null);

onMounted(() => {
  // Retrieve the diagram instance
  const diagramInstance = diagramRef.value.ej2Instances;
  diagramInstance.model = model;
  diagramInstance.updateFromModel();
});
</script>

<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
  <div id="app">
    <ejs-diagram ref="diagramRef" id="diagram" width="100%" height="700px" :snapSettings='snapSettings'/>
  </div>
</template>

<script>
import { DiagramComponent } from "@syncfusion/ej2-vue-diagrams";
import { UmlSequenceMessageType, SnapConstraints, UmlSequenceParticipantStereotype } from '@syncfusion/ej2-diagrams';

// Define the UML Sequence Diagram model with participants and messages
const model = {
  // Defines the participants involved in the sequence diagram
  participants: [
    { id: "User", content: "User", stereotype: UmlSequenceParticipantStereotype.Actor }, // User as an actor
    { id: "System", content: "System", showDestructionMarker: true, }, // System participant
    { id: "Logger", content: "Logger", showDestructionMarker: true, }, // Logger participant
    { id: "SessionManager", content: "SessionManager", } // SessionManager participant
  ],
  // Define messages exchanged between participants
  messages: [
    // User sends login request to System via Synchronous message
    {
      id: "MSG1", content: "Login Request", fromParticipantID: "User", toParticipantID: "System",
      type: UmlSequenceMessageType.Synchronous
    },
    // System replies to User with login response via Reply message
    {
      id: "MSG2", content: "Login Response", fromParticipantID: "System", toParticipantID: "User",
      type: UmlSequenceMessageType.Reply
    },
    // System sends log event to Logger via Asynchronous message
    {
      id: "MSG3", content: "Log Event", fromParticipantID: "System", toParticipantID: "Logger",
      type: UmlSequenceMessageType.Asynchronous
    },
    // System requests SessionManager to create session via Create message
    {
      id: "MSG4", content: "Create Session", fromParticipantID: "System", toParticipantID: "SessionManager",
      type: UmlSequenceMessageType.Create
    },
    // System requests SessionManager to delete session via Delete message
    {
      id: "MSG5", content: "Delete Session", fromParticipantID: "System", toParticipantID: "SessionManager",
      type: UmlSequenceMessageType.Delete
    },
    // System validates inputs itself via Self message
    {
      id: "MSG6", content: "Validate Inputs", fromParticipantID: "System", toParticipantID: "System",
      type: UmlSequenceMessageType.Self
    }
  ],
};

const snapSettings = { constraints: SnapConstraints.None };

export default {
  name: "App",
  components: { "ejs-diagram": DiagramComponent },
  data() {
    return {
        snapSettings: snapSettings
    }
  },
  mounted() {
    // Retrieve the diagram instance
    const diagramInstance = this.$refs.diagramRef.ej2Instances;
    diagramInstance.model = model;
    diagramInstance.updateFromModel();
  },
};
</script>

<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

Activation Boxes

UmlSequenceActivationBoxModel represents periods when a participant is active and processing a message. They appear as thin rectangles on participant lifelines.

UmlSequenceActivationBoxModel Properties

Property Type Description
id string | number A unique identifier for the activation box
startMessageID string | number ID of the message that initiates the activation
endMessageID string | number ID of the message that terminates the activation

The following code example illustrates how to create activation boxes:

<template>
  <div id="app">
    <ejs-diagram ref="diagramRef" id="diagram" width="100%" height="600px" :snapSettings='snapSettings'/>
  </div>
</template>

<script setup>
import { ref, onMounted } from 'vue';
import { DiagramComponent as EjsDiagram } from '@syncfusion/ej2-vue-diagrams';
import { UmlSequenceMessageType, SnapConstraints , UmlSequenceParticipantStereotype} from '@syncfusion/ej2-diagrams';

// Define the UML Sequence Diagram model with participants and activation boxes
const model = {
  // Defines the participants involved in the sequence diagram
  participants: [
    {
      id: "User",
      content: "User",
      stereotype: UmlSequenceParticipantStereotype.Actor
    },
    {
      id: "System",
      content: "System",
      showDestructionMarker: true,
      // Activation boxes for System
      activationBoxes: [
        {
          id: "ActSystem", // Unique identifier for the activation box
          startMessageID: "MSG1", // Message ID that marks the start of the activation
          endMessageID: "MSG2" // Message ID that marks the end of the activation
        }
      ]
    }
  ],
  // Define messages exchanged between participants
  messages: [
    {
      id: "MSG1", content: "Login Request", fromParticipantID: "User", toParticipantID: "System",
      type: UmlSequenceMessageType.Synchronous
    },
    {
      id: "MSG2", content: "Login Response", fromParticipantID: "System", toParticipantID: "User",
      type: UmlSequenceMessageType.Reply
    }
  ],
};

const snapSettings = { constraints: SnapConstraints.None };
const diagramRef = ref(null);

onMounted(() => {
  // Retrieve the diagram instance
  const diagramInstance = diagramRef.value.ej2Instances;
  diagramInstance.model = model;
  diagramInstance.updateFromModel();
});
</script>

<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
  <div id="app">
    <ejs-diagram ref="diagramRef" id="diagram" width="100%" height="600px" :snapSettings='snapSettings'/>
  </div>
</template>

<script>
import { DiagramComponent } from "@syncfusion/ej2-vue-diagrams";
import { UmlSequenceMessageType, SnapConstraints, UmlSequenceParticipantStereotype } from '@syncfusion/ej2-diagrams';

const // Define the UML Sequence Diagram model with participants and activation boxes
  model = {
    // Defines the participants involved in the sequence diagram
    participants: [
      {
        id: "User",
        content: "User",
        stereotype: UmlSequenceParticipantStereotype.Actor
      },
      {
        id: "System",
        content: "System",
        showDestructionMarker: true,
        // Activation boxes for System
        activationBoxes: [
          {
            id: "ActSystem", // Unique identifier for the activation box
            startMessageID: "MSG1", // Message ID that marks the start of the activation
            endMessageID: "MSG2" // Message ID that marks the end of the activation
          }
        ]
      }
    ],
    // Define messages exchanged between participants
    messages: [
      {
        id: "MSG1", content: "Login Request", fromParticipantID: "User", toParticipantID: "System",
        type: UmlSequenceMessageType.Synchronous
      },
      {
        id: "MSG2", content: "Login Response", fromParticipantID: "System", toParticipantID: "User",
        type: UmlSequenceMessageType.Reply
      }
    ],
  };
  
const snapSettings = { constraints: SnapConstraints.None };

export default {
  name: "App",
  components: { "ejs-diagram": DiagramComponent },
  data() {
    return {
        snapSettings: snapSettings
    }
  },
  mounted() {
    // Retrieve the diagram instance
    const diagramInstance = this.$refs.diagramRef.ej2Instances;
    diagramInstance.model = model;
    diagramInstance.updateFromModel();
  },
};
</script>

<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

Fragments

UmlSequenceFragmentModel groups a set of messages based on specific conditions in a sequence diagram. They are displayed as rectangular enclosures that visually separate conditional or looping interactions.

Types of Fragments

The UmlSequenceFragmentType enum defines the following fragment types:

Fragment Type Description Example
Optional Represents a sequence that is executed only if a specified condition is met; otherwise, it is skipped. Optional Fragment
Alternative Represents multiple conditional paths (if-else structure), where only one path executes based on the condition. Alternative Fragment
Loop Represents a repeating sequence of interactions that continues based on a loop condition. Loop Fragment

UmlSequenceFragmentModel Properties

Property Type Description
id string | number A unique identifier for the fragment
type UmlSequenceFragmentType Type of the fragment (Optional, Loop, Alternative)
conditions UmlSequenceFragmentConditionModel[] Collection of conditions for the fragment

UmlSequenceFragmentConditionModel Properties

Property Type Description
content string Text describing the condition or parameter
messageIds (string | number)[] Collection of message IDs included in this condition section
fragmentIds string[] Collection of nested fragments ids (for complex structures)

The following code example illustrates how to create fragments:

<template>
  <div id="app">
    <ejs-diagram ref="diagramRef" id="diagram" width="100%" height="700px" :snapSettings='snapSettings'/>
  </div>
</template>

<script setup>
import { ref, onMounted } from 'vue';
import { DiagramComponent as EjsDiagram } from '@syncfusion/ej2-vue-diagrams';
import { UmlSequenceMessageType, UmlSequenceFragmentType, SnapConstraints , UmlSequenceParticipantStereotype} from '@syncfusion/ej2-diagrams';

// Define the UML Sequence Diagram model
const model = {
  // Define the space between participants
  spaceBetweenParticipants: 300,
  participants: [
   { id: "Customer", content: "Customer", stereotype: UmlSequenceParticipantStereotype.Actor},
    { id: "OrderSystem", content: "Order System" },
    { id: "PaymentGateway", content: "Payment Gateway" }
  ],
  // Define the messages passed between participants
  messages: [
    {
      id: "MSG1", content: "Place Order", fromParticipantID: "Customer", toParticipantID: "OrderSystem",
      type: UmlSequenceMessageType.Synchronous
    },
    {
      id: "MSG2", content: "Check Stock Availability", fromParticipantID: "OrderSystem", toParticipantID: "OrderSystem",
      type: UmlSequenceMessageType.Synchronous
    },
    {
      id: "MSG3", content: "Stock Available", fromParticipantID: "OrderSystem", toParticipantID: "Customer",
      type: UmlSequenceMessageType.Reply
    },
    {
      id: "MSG4", content: "Process Payment", fromParticipantID: "OrderSystem", toParticipantID: "PaymentGateway",
      type: UmlSequenceMessageType.Synchronous
    },
    {
      id: "MSG5", content: "Payment Successful", fromParticipantID: "PaymentGateway", toParticipantID: "OrderSystem",
      type: UmlSequenceMessageType.Reply
    },
    {
      id: "MSG6", content: "Order Confirmed and Shipped", fromParticipantID: "OrderSystem", toParticipantID: "Customer",
      type: UmlSequenceMessageType.Reply
    },
    {
      id: "MSG7", content: "Payment Failed", fromParticipantID: "PaymentGateway", toParticipantID: "OrderSystem",
      type: UmlSequenceMessageType.Reply
    },
    {
      id: "MSG8", content: "Retry Payment", fromParticipantID: "OrderSystem", toParticipantID: "Customer",
      type: UmlSequenceMessageType.Reply
    }
  ],
  // Define fragments for conditional visual representation
  fragments: [
    // Child Fragment 1 (Optional)
    {
      id: 1,
      type: UmlSequenceFragmentType.Optional,
      conditions: [
        {
          content: "if item is in stock",
          messageIds: ["MSG4"]
        }
      ]
    },
    // Child Fragment 2 (Alternative)
    {
      id: 2,
      type: UmlSequenceFragmentType.Alternative,
      conditions: [
        {
          content: "if payment is successful",
          messageIds: ["MSG5", "MSG6"]
        },
        {
          content: "if payment fails",
          messageIds: ["MSG7", "MSG8"]
        }
      ]
    },
    // Parent Fragment (Loop)
    {
      id: 3,
      type: UmlSequenceFragmentType.Loop,
      conditions: [
        {
          content: "while attempts less than 3",
          // Use IDs of child fragments for nested conditions
          fragmentIds: ['1', '2'],
        }
      ]
    },
  ],
};

const snapSettings = { constraints: SnapConstraints.None };
const diagramRef = ref(null);

onMounted(() => {
  // Retrieve the diagram instance
  const diagramInstance = diagramRef.value.ej2Instances;
  diagramInstance.model = model;
  diagramInstance.updateFromModel();
});
</script>

<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>
<template>
  <div id="app">
    <ejs-diagram ref="diagramRef" id="diagram" width="100%" height="700px" :snapSettings='snapSettings'/>
  </div>
</template>

<script>
import { DiagramComponent } from "@syncfusion/ej2-vue-diagrams";
import { UmlSequenceMessageType, UmlSequenceFragmentType, SnapConstraints, UmlSequenceParticipantStereotype } from '@syncfusion/ej2-diagrams';

const  // Define the UML Sequence Diagram model
  model = {
    // Define the space between participants
    spaceBetweenParticipants: 300,
    participants: [ { id: "Customer", content: "Customer", stereotype: UmlSequenceParticipantStereotype.Actor},
    { id: "OrderSystem", content: "Order System" },
    { id: "PaymentGateway", content: "Payment Gateway" }],
    // Define the messages passed between participants
    messages: [
      {
        id: "MSG1", content: "Place Order", fromParticipantID: "Customer", toParticipantID: "OrderSystem",
        type: UmlSequenceMessageType.Synchronous
      },
      {
        id: "MSG2", content: "Check Stock Availability", fromParticipantID: "OrderSystem", toParticipantID: "OrderSystem",
        type: UmlSequenceMessageType.Synchronous
      },
      {
        id: "MSG3", content: "Stock Available", fromParticipantID: "OrderSystem", toParticipantID: "Customer",
        type: UmlSequenceMessageType.Reply
      },
      {
        id: "MSG4", content: "Process Payment", fromParticipantID: "OrderSystem", toParticipantID: "PaymentGateway",
        type: UmlSequenceMessageType.Synchronous
      },
      {
        id: "MSG5", content: "Payment Successful", fromParticipantID: "PaymentGateway", toParticipantID: "OrderSystem",
        type: UmlSequenceMessageType.Reply
      },
      {
        id: "MSG6", content: "Order Confirmed and Shipped", fromParticipantID: "OrderSystem", toParticipantID: "Customer",
        type: UmlSequenceMessageType.Reply
      },
      {
        id: "MSG7", content: "Payment Failed", fromParticipantID: "PaymentGateway", toParticipantID: "OrderSystem",
        type: UmlSequenceMessageType.Reply
      },
      {
        id: "MSG8", content: "Retry Payment", fromParticipantID: "OrderSystem", toParticipantID: "Customer",
        type: UmlSequenceMessageType.Reply
      }
    ],
    // Define fragments for conditional visual representation
    fragments: [
      // Child Fragment 1 (Optional)
      {
        id: 1,
        type: UmlSequenceFragmentType.Optional,
        conditions: [
          {
            content: "if item is in stock",
            messageIds: ["MSG4"]
          }
        ]
      },
      // Child Fragment 2 (Alternative)
      {
        id: 2,
        type: UmlSequenceFragmentType.Alternative,
        conditions: [
          {
            content: "if payment is successful",
            messageIds: ["MSG5", "MSG6"]
          },
          {
            content: "if payment fails",
            messageIds: ["MSG7", "MSG8"]
          }
        ]
      },
      // Parent Fragment (Loop)
      {
        id: 3,
        type: UmlSequenceFragmentType.Loop,
        conditions: [
          {
            content: "while attempts less than 3",
            // Use IDs of child fragments for nested conditions
            fragmentIds: ['1', '2'],
          }
        ]
      },
    ],
  };
  
const snapSettings = { constraints: SnapConstraints.None };

export default {
  name: "App",
  components: { "ejs-diagram": DiagramComponent },
  data() {
    return {
        snapSettings: snapSettings
    }
  },
  mounted() {
    // Retrieve the diagram instance
    const diagramInstance = this.$refs.diagramRef.ej2Instances;
    diagramInstance.model = model;
    diagramInstance.updateFromModel();
  },
};
</script>

<style>
@import "../node_modules/@syncfusion/ej2-vue-diagrams/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-base/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-popups/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-splitbuttons/styles/tailwind3.css";
@import "../node_modules/@syncfusion/ej2-navigations/styles/tailwind3.css";
</style>

Customizing Participant Spacing in Sequence Diagram

The spaceBetweenParticipants property in UmlSequenceDiagramModel controls the horizontal spacing between participants. The default value is 100, and it can be adjusted based on your layout requirements.

// Define the UML Sequence Diagram model
const model = {
  // Define the space between participants
  spaceBetweenParticipants: 300,
  participants: participants,    // collection of participants in the sequence diagram  
  messages: messages,            // collection of messages exchanged between participants  
  fragments: fragments           // collection of sequence diagram fragments (opt, alt, loop) 
}